

#include "lcd.h"
#include "usart.h"
#include "rtc.h"
#include <avr/pgmspace.h>
#include <avr/io.h>
#include <util/delay.h>
//#include "uTFT_ST7735.h"
#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>




void set_duty_cycle(float f) {
	OCR1A = f * ICR1;
}

void rotate_servo(float angle) {
	const static float duty_cycle_0 = 0.02;
	const static float duty_cycle_180 = 0.1;
	
	float duty_cycle =
		angle / 180 * (duty_cycle_180 - duty_cycle_0) + duty_cycle_0;
	
	set_duty_cycle(duty_cycle);
}
void pwm_init() {
	DDRD |= (1 << PD4);
	DDRD |= (1 << PD5);

	// Fast PWM, TOP ICR1
	TCCR1A |= (2 << WGM10);
	TCCR1B |= (3 << WGM12);

	// Clear OC1A, OC1B on Compare Match and set at bottom
	TCCR1A |= (1 << COM1A1);
	TCCR1A |= (1 << COM1B1);

	// Prescaler of 8
	TCCR1B |= (1 << CS11);

	// Frequency of 50 HZ
	ICR1 = 40000;
}




void servo_init() {
	pwm_init();
}


void set_RTC_time(rtc_t *rtc) {

	rtc->hour = 0x21;
    rtc->min =  0x45;
    rtc->sec =  0x00;
    rtc->date = 0x25;
    rtc->month = 0x05;
    rtc->year = 0x17;
    rtc->weekDay = 4;

    RTC_SetDateTime(rtc);
}










/* intreruperea pentru pin PD6 - microswitch */
ISR(PCINT0_vect) {
    // PD6 apasat
    if((PIND & (1 << PD6)) == 0)
    {

        //cel de al doilea microswitch
		if((PINB & (1 << PB4)) == 0){
			servo_init();
			rotate_servo(100);
			_delay_ms(2000);
			rotate_servo(220);
			_delay_ms(2000);
			DDRD &= ~(1 << PD5);
			
			}

    }



    
}



int main()
{
    
   	// LCD_init();
    
	rtc_t rtc;
	RTC_Init();
	
	while(1)

    {

        RTC_GetDateTime(&rtc);
		

		_delay_ms(100);
    }
	


   
    return 0;
}

